from heapq import heappush, heappop
import time


class Schedualer:
    
    class Event:
        def __init__(self, method, argv):
            self.method = method
            self.argv = argv
        def Execute(self):
            self.method(*self.argv)
    
    def __init__(self):
        self.events = []
        self.time_min = -1
        self.time = -3600

    def StartTimer(self):
        self.start_time = time.time()
        self.time = 0
        
    def Post(self, pTime, callback, *argv):
        self.time = time.time() - self.start_time
        self.PostAt(self.time + pTime, callback, *argv)

    def PostAt(self, time, callback, *argv):
        heappush(self.events, (time, Schedualer.Event(callback, argv)) )
        if self.time_min == -1 or (self.time_min > -1 and time < self.time_min):
            self.time_min = time
            
    def Poll(self):
        self.time = time.time() - self.start_time
        while self.time_min != -1 and self.time_min < self.time:
            tmp, e = heappop(self.events)
            # print "** Event ** ", self.time, "-", e.method.__name__, e.argv
            if len(self.events) == 0:
                self.time_min = -1
            else:
                self.time_min = self.events[0][0]
            e.Execute()
            
        
        
