import random
from scene import *
from game.m_EntityTypes import *
from scene.m_Shapes import *
from random import randint



class MedicBox(IEntityObserver):

    def __init__(self, gameController, sceneController, x, y):
        self.sceneController = sceneController
        self.gameController = gameController
        self.shape = SHAPE_CIRCLE_12
        self.health = randint(10, 60)
        box = self.sceneController.CreateNewEntity(TYPE_MEDIC_BOX, x, y)
        self.sceneController.AttachObserverToEntity(box, self)
        

    def NotifyCollisionWithEntity(self, medic_box_id, other_entity_id):
        player_id = self.gameController.GetPlayerByEntityId(other_entity_id)
        if player_id != None and self.gameController.GetPlayerHealth(player_id) < 100:
            self.gameController.IncreasePlayerHealth(player_id, self.health)
            self.sceneController.DeleteEntity(medic_box_id)

            
    def NotifyCollisionWithLand(self, entity_id, x, y, side):
        if x == -1:
            self.sceneController.DeleteEntity(entity_id)

            
    def NotifyExplosion(self, entity_id, vx, vy, power):
        if self.sceneController.EntityExists(entity_id) == False: return
        x, y = self.sceneController.GetEntityPosCenter(entity_id)
        flame = self.sceneController.CreateNewEntity(TYPE_FLAME2)
        x0, y0 = self.sceneController.GetEntityPosCenter(flame)
        x -= x0
        y -= y0
        self.sceneController.RemoveLand(int(x),  int(y), self.shape)
        self.sceneController.SetEntityPos(flame, x, y)
        self.sceneController.DeleteEntity(entity_id)
        self.sceneController.CreateExplosion(x, y, 0, 0, 25, 15)



