from m_Net import *
from m_Messeges import *
from time import sleep
import sys


usage = \
"""Usage: python test_server.py <port> 
"""


class TestServer:

    def __init__(self):
        self.net = Net()

    def HandleListenerError(self, sender, text):
        print "Error:", text
        
    def HandleConnectionError(self, sender, text):
        print "Client", sender.ip_addr, sender.port, "disconnected"
        
    def HandleNewConnection(self, newHost):
        print "===> new host connected:", newHost.ip_addr, newHost.port
        newHost.RegisterObjectReceivedHandler(TextMessege.type, self.HandleTextMessege)
        newHost.RegisterErrorHandler(self.HandleConnectionError)
    
    def HandleTextMessege(self, sender, msg):
        print "===> new msg from", sender.ip_addr, sender.port, ":", msg.text
    
    def Start(self, port):
        listener = NetListener(self.net, port)
        listener.RegisterNewConnectionHandler(self.HandleNewConnection)
        listener.RegisterErrorHandler(self.HandleListenerError)
        listener.Start()
        
        print "Server started."
        
        while True:
            self.net.Poll()
            sleep(0.1)


if len(sys.argv) < 2:
    print usage
    sys.exit(1)            


server = TestServer()
server.Start(int(sys.argv[1]))


