from pgu import gui
import pygame



class ChatBox:
    
    def __init__(self, game, player_name):
        self.game = game
        self.player_name = player_name
        self.screen = game.screen
        self.app = gui.App()
        self.main = gui.Container()
        self.input = gui.Input(cls='input_network_game_chat', size=80)
        self.input.style.width = 550
        self.main.add(self.input, 5, 4)
        self.app.init(self.main)
        self.is_focused = False
        
        # functions to be called when text is entered.
        # the callback should expect one arg - the text entered.
        self.inputCallbacks = [] 
        
    def event(self, e):
        self.app.event(e)
        if e.type == gui.KEYDOWN:    
            if e.key == gui.K_RETURN:
                text = self.input.value.strip()
                if len(text) > 0:
                    self.handle_input(text)
                self.input.value = ""
        
    def Paint(self):
        self.app.paint(self.screen)
        
    def Update(self):
        self.app.update(self.screen)
        
    def handle_input(self, text):
        for cb in self.inputCallbacks: cb(text)

    def ToggleFocus(self):
        if self.is_focused:
            self.is_focused = False
            self.input.blur()
        else:
            self.is_focused = True
            self.input.focus()

    def HandleChatMessage(self, sender, msg):
        if self.game.started:
            self.game.camera_bottom_dlg.Open(msg.player_name + ": " + msg.text)

    def IsFocused(self):
        return self.is_focused
        
