import sys, os
from scene import PhysicsEngine, Level, LevelRep, LocalSceneController # for psyco
from game.m_Game import Game # for psyco


print "checking for dependencies..."


try:
    import pygame
    from pygame.locals import *
    print "pygame - OK"
except:
    print "pygame is not installed."
    print "get it at www.pygame.org and try again."
    sys.exit(1)
    

try:
    import Numeric
    import pygame.surfarray
    print "pygame.surfarray - OK"
except:
    print "Numeric is not installed."
    print "please get it and try again. (Numeric is an array library for"
    print "python, also known as python-numeric"
    sys.exit(1)


try:
    import pygame.font
    pygame.font.init()
    print "pygame.font - OK"
except:
    print "pygame is installed without SDL_ttf (true type font) support."
    print "please install SDL_ttf, and re-install pygame."
    sys.exit(1)


try:
    import psyco
    psyco.bind(PhysicsEngine._move_entity, 2)
    psyco.bind(LocalSceneController.CreateExplosion, 2)
    psyco.bind(Level.RemoveLand, 2)
    psyco.bind(LevelRep.NotifyLandRemoval, 2)
    psyco.bind(Game.Run)
    print "psyco - OK"
except ImportError:
    print "no psyco installed. I can live with without it."
    
    
print ""
print "ready to run!"
print ""

from pgu import gui
from app import App
from tools.m_Thread import CuteThread # another cute optimization!


# parrallelizing with Cute Thread

cute_thread = CuteThread()
cute_thread.start()
Level.RemoveLand = cute_thread.CreateInstanceMethod( Level.RemoveLand )

gui.theme.load(os.path.join('data', 'themes', 'default'))

app = App(pygame.FULLSCREEN)

app.Run()

cute_thread.Quit()
pygame.quit()



