"""
Shapes defines a series of points. these points are accessible
through the Walk method.

This module defines some shape objects and their id's.
"""


# id's

SHAPE_CIRCLE_5 =  0
SHAPE_CIRCLE_12 = 1
SHAPE_CIRCLE_25 = 2

# see the 'shapes' list at the end of this file


class Shape:
    """
    a Shape is a collecion of points.
    since performance is everything, the interface of this class is not much
    intuitive... 
    a shape have a list of horizontal lines, called hlines,
    where each item in hlines is a tuple of (y, x_left, x_right)
    """

    def __init__(self, id):
        self.id = id
        self.hlines = []



class Circle(Shape):
    
    def __init__(self, id, r):
        Shape.__init__(self, id)
        self.r = r
        x = 0
        y = r
        p = (5 - 4*r)/4
        while x < y:
            self.add_points(y, x)
            x += 1
            if p < 0:
                p += 2*x + 1
            else:
                self.add_points(x-1, y)
                y -= 1
                p += 2*(x-y)+1
        self.add_points(x, y)
        self.add_points(y, x)
        
    def add_points(self, x, y):
        if (y, -x, x) not in self.hlines:
            self.hlines.append((y, -x, x))
            self.hlines.append((-y, -x, x))



shapes = [Circle(SHAPE_CIRCLE_5, 5),
          Circle(SHAPE_CIRCLE_12, 12),
          Circle(SHAPE_CIRCLE_25, 25)]


