import pygame
import os



class ImageInfo:
    def __init__(self):
        self.s = None
        self.inner_rect = None


def get_image_inner_rect(s):
    keyc = s.get_at((0, 0))
    w, h = s.get_size()
    x0 = w - 1
    y0 = h - 1
    x1 = 0
    y1 = 0

    y = 0
    while y < h:
        x = 0
        while x < w:
            if s.get_at((x, y)) != keyc:
                x0 = min(x0, x)
                y0 = min(y0, y)
                x1 = max(x1, x)
                y1 = max(y1, y)
            x += 1
        y += 1

    return (x0, y0, x1, y1)
    

def main(path):
    images = []
    fnames = os.listdir(path)
    fnames.sort()
    for fname in fnames:
        fname = os.path.join(path, fname)
        try:
            s = pygame.image.load(fname)
            img = ImageInfo()
            img.s = s
            img.inner_rect = get_image_inner_rect(s)
            images.append(img)
        except: print "skipping file", fname
        
    if len(images) == 0:
        print "no images found. quitting."
        return
        
    x0, y0, x1, y1 = images[0].inner_rect
    for img in images[1:]:
        x0 = min(x0, img.inner_rect[0])
        y0 = min(y0, img.inner_rect[1])
        x1 = max(x1, img.inner_rect[2])
        y1 = max(y1, img.inner_rect[3])

    w = x1 - x0 + 1
    h = y1 - y0 + 1
    print "found", len(images), "images."
    print "calculated bounding rectangle is:", x0, y0, w, h
    print "now I'm going to build two set of images:"
    print " (*) the original found images, as TGA, resized to the rect"
    print "     size and moved by the rect offset."
    print " (*) horizontal flipped copy of the first set."
    print "enter prefix for the first set:"
    prefix1 = raw_input()
    print "enter prefix for the second set:"
    prefix2 = raw_input()

    count = 0
    s = pygame.Surface((w, h + 1))
    for img in images:
        keyc = img.s.get_at((0, 0))
        s.fill(keyc)
        s.blit(img.s, (0, 1), (x0, y0, w, h))
        pygame.image.save(s, prefix1 + str(count) + ".tga")
        s = pygame.transform.flip(s, True, False)
        pygame.image.save(s, prefix2 + str(count) + ".tga")
        count += 1
        

main('.')

