import random
from scene import Entity
from game.m_EntityTypes import *


class Flame1(Entity):
    
    def __init__(self, res=None, level=None, prototype=None):
        Entity.__init__(self, res, level, prototype)
        self.time = 0
        self.time1 = 300
        self.time2 = 600
        self.time3 = 900
        self.vx_array = []
        self.vy_array = []
        for i in xrange(0, 4):
            self.vx_array.append(random.random() * 50 - 25)
            self.vy_array.append(random.random() * 50 - 25)
        
    def Clone(self):
        return Flame1(prototype=self)
        
    def Advance(self, time):
        Entity.Advance(self, time)
        if self._anims[self._anim_index].cycles > 0:
            self.level.RemoveEntity(self)
            return
        self.time += time
        if self.time < self.time1:
            self.vx = self.vx_array[0]
            self.vy = self.vy_array[0]
        elif self.time < self.time2:
            self.vx = self.vx_array[1]
            self.vy = self.vy_array[1]
        elif self.time < self.time2:
            self.vx = self.vx_array[2]
            self.vy = self.vy_array[2]
        elif self.time < self.time3:
            self.vx = self.vx_array[3]
            self.vy = self.vy_array[3]


class Flame2(Entity):
    
    def __init__(self, res=None, level=None, prototype=None):
        Entity.__init__(self, res, level, prototype)
        self.anims[0].delay += random.randint(0, 6) - 3
        
    def Clone(self):
        return Flame2(prototype=self)
        
    def Advance(self, time):
        Entity.Advance(self, time)
        if self.anims[0].cycles > 0:
            self.level.RemoveEntity(self)
            
